VTK: vtkStackedTreeLayoutStrategy Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkStackedTreeLayoutStrategy Class Reference

lays out tree in stacked boxes or rings More...

`#include <vtkStackedTreeLayoutStrategy.h>`

Inheritance diagram for vtkStackedTreeLayoutStrategy:
[legend]
Collaboration diagram for vtkStackedTreeLayoutStrategy:
[legend]

## Public Types
typedef vtkAreaLayoutStrategy | Superclass
Public Types inherited from vtkAreaLayoutStrategy
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkStackedTreeLayoutStrategy * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Layout (vtkTree *inputTree, vtkDataArray *sectorArray, vtkDataArray *sizeArray) override
| Perform the layout of the input tree, and store the sector bounds of each vertex as a tuple (innerRadius, outerRadius, startAngle, endAngle) in a data array. More...
void | LayoutEdgePoints (vtkTree *inputTree, vtkDataArray *sectorArray, vtkDataArray *sizeArray, vtkTree *edgeRoutingTree) override
| Fill edgeRoutingTree with points suitable for routing edges of an overlaid graph. More...
virtual void | SetInteriorRadius (double)
| Define the tree ring's interior radius. More...
virtual double | GetInteriorRadius ()
virtual void | SetRingThickness (double)
| Define the thickness of each of the tree rings. More...
virtual double | GetRingThickness ()
virtual void | SetRootStartAngle (double)
| Define the start angle for the root node. More...
virtual double | GetRootStartAngle ()
virtual void | SetRootEndAngle (double)
| Define the end angle for the root node. More...
virtual double | GetRootEndAngle ()
virtual void | SetUseRectangularCoordinates (bool)
| Define whether or not rectangular coordinates are being used (as opposed to polar coordinates). More...
virtual bool | GetUseRectangularCoordinates ()
virtual void | UseRectangularCoordinatesOn ()
virtual void | UseRectangularCoordinatesOff ()
virtual void | SetReverse (bool)
| Define whether to reverse the order of the tree stacks from low to high. More...
virtual bool | GetReverse ()
virtual void | ReverseOn ()
virtual void | ReverseOff ()
virtual void | SetInteriorLogSpacingValue (double)
| The spacing of tree levels in the edge routing tree. More...
virtual double | GetInteriorLogSpacingValue ()
vtkIdType | FindVertex (vtkTree *tree, vtkDataArray *array, float pnt[2]) override
| Returns the vertex id that contains pnt (or -1 if no one contains it). More...
Public Member Functions inherited from vtkAreaLayoutStrategy
vtkAreaLayoutStrategy * | NewInstance () const
virtual void | SetShrinkPercentage (double)
virtual double | GetShrinkPercentage ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkStackedTreeLayoutStrategy * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkStackedTreeLayoutStrategy * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAreaLayoutStrategy
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAreaLayoutStrategy * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkStackedTreeLayoutStrategy ()
| ~vtkStackedTreeLayoutStrategy () override
void | ComputeEdgeRoutingPoints (vtkTree *inputTree, vtkDataArray *coordsArray, vtkTree *outputTree)
void | LayoutChildren (vtkTree *tree, vtkDataArray *coordsArray, vtkDataArray *sizeArray, vtkIdType nchildren, vtkIdType parent, vtkIdType begin, float parentInnerRad, float parentOuterRad, float parentStartAng, float parentEndAng)
Protected Member Functions inherited from vtkAreaLayoutStrategy
| vtkAreaLayoutStrategy ()
| ~vtkAreaLayoutStrategy () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
float | InteriorRadius
float | RingThickness
float | RootStartAngle
float | RootEndAngle
bool | UseRectangularCoordinates
bool | Reverse
double | InteriorLogSpacingValue
Protected Attributes inherited from vtkAreaLayoutStrategy
double | ShrinkPercentage
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

lays out tree in stacked boxes or rings

Performs a tree ring layout or "icicle" layout on a tree. This involves assigning a sector region to each vertex in the tree, and placing that information in a data array with four components per tuple representing (innerRadius, outerRadius, startAngle, endAngle).

This class may be assigned as the layout strategy to vtkAreaLayout.

Thanks:
  Thanks to Jason Shepherd from Sandia National Laboratories for help developing this class.

Definition at line 46 of file vtkStackedTreeLayoutStrategy.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAreaLayoutStrategy vtkStackedTreeLayoutStrategy::Superclass

Definition at line 50 of file vtkStackedTreeLayoutStrategy.h.

## Constructor & Destructor Documentation

## ◆ vtkStackedTreeLayoutStrategy()

vtkStackedTreeLayoutStrategy::vtkStackedTreeLayoutStrategy | ( |  | ) |
| protected

## ◆ ~vtkStackedTreeLayoutStrategy()

vtkStackedTreeLayoutStrategy::~vtkStackedTreeLayoutStrategy | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkStackedTreeLayoutStrategy* vtkStackedTreeLayoutStrategy::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkStackedTreeLayoutStrategy::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkStackedTreeLayoutStrategy::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkAreaLayoutStrategy.

## ◆ SafeDownCast()

static vtkStackedTreeLayoutStrategy* vtkStackedTreeLayoutStrategy::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkStackedTreeLayoutStrategy::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkAreaLayoutStrategy.

## ◆ NewInstance()

vtkStackedTreeLayoutStrategy* vtkStackedTreeLayoutStrategy::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkStackedTreeLayoutStrategy::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkAreaLayoutStrategy.

## ◆ Layout()

void vtkStackedTreeLayoutStrategy::Layout | ( | vtkTree * | inputTree,
|  | vtkDataArray * | sectorArray,
|  | vtkDataArray * | sizeArray
| ) |  |
| overridevirtual

Perform the layout of the input tree, and store the sector bounds of each vertex as a tuple (innerRadius, outerRadius, startAngle, endAngle) in a data array.

Implements vtkAreaLayoutStrategy.

## ◆ LayoutEdgePoints()

void vtkStackedTreeLayoutStrategy::LayoutEdgePoints | ( | vtkTree * | inputTree,
|  | vtkDataArray * | sectorArray,
|  | vtkDataArray * | sizeArray,
|  | vtkTree * | edgeRoutingTree
| ) |  |
| overridevirtual

Fill edgeRoutingTree with points suitable for routing edges of an overlaid graph.

Reimplemented from vtkAreaLayoutStrategy.

## ◆ SetInteriorRadius()

virtual void vtkStackedTreeLayoutStrategy::SetInteriorRadius | ( | double |  | ) |
| virtual

Define the tree ring's interior radius.

## ◆ GetInteriorRadius()

virtual double vtkStackedTreeLayoutStrategy::GetInteriorRadius | ( |  | ) |
| virtual

## ◆ SetRingThickness()

virtual void vtkStackedTreeLayoutStrategy::SetRingThickness | ( | double |  | ) |
| virtual

Define the thickness of each of the tree rings.

## ◆ GetRingThickness()

virtual double vtkStackedTreeLayoutStrategy::GetRingThickness | ( |  | ) |
| virtual

## ◆ SetRootStartAngle()

virtual void vtkStackedTreeLayoutStrategy::SetRootStartAngle | ( | double |  | ) |
| virtual

Define the start angle for the root node.

NOTE: It is assumed that the root end angle is greater than the root start angle and subtends no more than 360 degrees.

## ◆ GetRootStartAngle()

virtual double vtkStackedTreeLayoutStrategy::GetRootStartAngle | ( |  | ) |
| virtual

## ◆ SetRootEndAngle()

virtual void vtkStackedTreeLayoutStrategy::SetRootEndAngle | ( | double |  | ) |
| virtual

Define the end angle for the root node.

NOTE: It is assumed that the root end angle is greater than the root start angle and subtends no more than 360 degrees.

## ◆ GetRootEndAngle()

virtual double vtkStackedTreeLayoutStrategy::GetRootEndAngle | ( |  | ) |
| virtual

## ◆ SetUseRectangularCoordinates()

virtual void vtkStackedTreeLayoutStrategy::SetUseRectangularCoordinates | ( | bool |  | ) |
| virtual

Define whether or not rectangular coordinates are being used (as opposed to polar coordinates).

## ◆ GetUseRectangularCoordinates()

virtual bool vtkStackedTreeLayoutStrategy::GetUseRectangularCoordinates | ( |  | ) |
| virtual

## ◆ UseRectangularCoordinatesOn()

virtual void vtkStackedTreeLayoutStrategy::UseRectangularCoordinatesOn | ( |  | ) |
| virtual

## ◆ UseRectangularCoordinatesOff()

virtual void vtkStackedTreeLayoutStrategy::UseRectangularCoordinatesOff | ( |  | ) |
| virtual

## ◆ SetReverse()

virtual void vtkStackedTreeLayoutStrategy::SetReverse | ( | bool |  | ) |
| virtual

Define whether to reverse the order of the tree stacks from low to high.

## ◆ GetReverse()

virtual bool vtkStackedTreeLayoutStrategy::GetReverse | ( |  | ) |
| virtual

## ◆ ReverseOn()

virtual void vtkStackedTreeLayoutStrategy::ReverseOn | ( |  | ) |
| virtual

## ◆ ReverseOff()

virtual void vtkStackedTreeLayoutStrategy::ReverseOff | ( |  | ) |
| virtual

## ◆ SetInteriorLogSpacingValue()

virtual void vtkStackedTreeLayoutStrategy::SetInteriorLogSpacingValue | ( | double |  | ) |
| virtual

The spacing of tree levels in the edge routing tree.

Levels near zero give more space to levels near the root, while levels near one (the default) create evenly-spaced levels. Levels above one give more space to levels near the leaves.

## ◆ GetInteriorLogSpacingValue()

virtual double vtkStackedTreeLayoutStrategy::GetInteriorLogSpacingValue | ( |  | ) |
| virtual

## ◆ FindVertex()

vtkIdType vtkStackedTreeLayoutStrategy::FindVertex | ( | vtkTree * | tree,
|  | vtkDataArray * | array,
|  | float | pnt[2]
| ) |  |
| overridevirtual

Returns the vertex id that contains pnt (or -1 if no one contains it).

Implements vtkAreaLayoutStrategy.

## ◆ ComputeEdgeRoutingPoints()

void vtkStackedTreeLayoutStrategy::ComputeEdgeRoutingPoints | ( | vtkTree * | inputTree,
|  | vtkDataArray * | coordsArray,
|  | vtkTree * | outputTree
| ) |  |
| protected

## ◆ LayoutChildren()

void vtkStackedTreeLayoutStrategy::LayoutChildren | ( | vtkTree * | tree,
|  | vtkDataArray * | coordsArray,
|  | vtkDataArray * | sizeArray,
|  | vtkIdType | nchildren,
|  | vtkIdType | parent,
|  | vtkIdType | begin,
|  | float | parentInnerRad,
|  | float | parentOuterRad,
|  | float | parentStartAng,
|  | float | parentEndAng
| ) |  |
| protected

## Member Data Documentation

## ◆ InteriorRadius

float vtkStackedTreeLayoutStrategy::InteriorRadius
| protected

Definition at line 145 of file vtkStackedTreeLayoutStrategy.h.

## ◆ RingThickness

float vtkStackedTreeLayoutStrategy::RingThickness
| protected

Definition at line 146 of file vtkStackedTreeLayoutStrategy.h.

## ◆ RootStartAngle

float vtkStackedTreeLayoutStrategy::RootStartAngle
| protected

Definition at line 147 of file vtkStackedTreeLayoutStrategy.h.

## ◆ RootEndAngle

float vtkStackedTreeLayoutStrategy::RootEndAngle
| protected

Definition at line 148 of file vtkStackedTreeLayoutStrategy.h.

## ◆ UseRectangularCoordinates

bool vtkStackedTreeLayoutStrategy::UseRectangularCoordinates
| protected

Definition at line 149 of file vtkStackedTreeLayoutStrategy.h.

## ◆ Reverse

bool vtkStackedTreeLayoutStrategy::Reverse
| protected

Definition at line 150 of file vtkStackedTreeLayoutStrategy.h.

## ◆ InteriorLogSpacingValue

double vtkStackedTreeLayoutStrategy::InteriorLogSpacingValue
| protected

Definition at line 151 of file vtkStackedTreeLayoutStrategy.h.

The documentation for this class was generated from the following file:

- Infovis/Layout/vtkStackedTreeLayoutStrategy.h